''++ -------------------------------------------------------------------------
'' mandelbrot-fixed16-vga-320x240x2.bas
''
''                     translated to BASIC from mandelbrot16-20180406-fds.spin
''
'' set the VGA pin(group) as neede a few lines below.
''-- -------------------------------------------------------------------------

dim vga as class using "VGA64_BMPEngine.spin"

const pingroup = 2
const bpp = 2 ' bits per pixel

const xsize = 320
const ysize = 240

dim as ulong bitmap(((xsize*ysize)/32)*bpp)

vga.bmpenginestart(pingroup,bpp,xsize,ysize,@bitmap) ' check rc

vga.displaycolor(0,vga.black)
vga.displaycolor(1,vga.red)
vga.displaycolor(2,vga.green)
vga.displaycolor(3,vga.blue)

''++ ===========================================================================

const xmin = (-21<<12)/10
const xmax = (  7<<12)/10

const ymin = (-12<<12)/10
const ymax = ( 12<<12)/10

const maxiter = 32

const MPX = xsize-1
const MPY = ysize-1

const dx = (xmax-xmin)/MPX
const dy = (ymax-ymin)/MPY

const c4 = 4<<12

dim as integer x,y,x2,y2,cx,cy,iter

cy = ymin
for py = 0 to MPY
  cx = xmin
  for px = 0 to MPX
    x = 0
    y = 0
    x2 = 0
    y2 = 0
    iter = 0
    while iter < maxiter and x2+y2 <= c4
      y = ((x*y)>>11)+cy
      x = x2-y2+cx
      iter = iter+1
      x2 = (x*x)>>12
      y2 = (y*y)>>12
    end while
    cx = cx+dx
    vga.plotpixel(iter and 3,px,py,@bitmap)
  next px
  cy = cy+dy
next py

''-- ===========================================================================

''++
do
loop
''--
